%Волновое уравнение, аналитическое решение без начальных скоростей
c=[];c1=[];c2=[];c3=[];y=[];x=[];
a=.5;			% квадрат скорости*шаг по времени*шаг по х
x0=0.99;			% положение максимального отклонения
y0=-20;			% величина максимального отклонения
n=20;			% число членов ряда
figure(1)
for t=0:.5:5		% моменты времени
for i=1:21
x(i)=(i-1)/20;		% точки струны
for k=1:n
l=k*pi;
% расчет констант
c1(k)=-x0*cos(l*x0)/l+sin(l*x0)/l^2-(-0*cos(l*0)/l+sin(l*0)/l^2);
c2(k)=cos(l*1)/l-cos(l*x0)/l;
c3(k)=-(-1*cos(l*1)/l+sin(l*1)/l^2-(-x0*cos(l*x0)/l+sin(l*x0)/l^2));
c(k)=(y0/x0)*c1(k)+(y0/(1-x0))*(-c2(k)+c3(k));
% отклонения точек струны - члены ряда
y(k)=2*c(k)*sin(l*x(i))*cos(a*l*t);
end
% отклонения точек струны - сумма ряда
z(i)=sum(y);
end
% графический вывод результатов
plot(x,z)
%axis([0 1 -0.2 .2]);
line([0 1],[0 0])
xlabel('x/l')
ylabel('y')
pause(.5);			% пауза между картинками
hold off
hold on
end

